VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Sprite Animation Sample"
   ClientHeight    =   2400
   ClientLeft      =   1515
   ClientTop       =   1800
   ClientWidth     =   3390
   LinkTopic       =   "Form1"
   Picture         =   "Main.frx":0000
   ScaleHeight     =   160
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   226
   Begin VB.PictureBox picCurFrame 
      AutoRedraw      =   -1  'True
      Height          =   855
      Left            =   0
      ScaleHeight     =   795
      ScaleWidth      =   975
      TabIndex        =   1
      Top             =   1500
      Visible         =   0   'False
      Width           =   1035
   End
   Begin VB.CommandButton cmdPlay 
      Caption         =   "&Play Animation"
      Height          =   375
      Left            =   1020
      TabIndex        =   0
      Top             =   1980
      Width           =   1395
   End
   Begin VB.Image imgMask 
      Height          =   750
      Index           =   3
      Left            =   2580
      Picture         =   "Main.frx":4166
      Top             =   840
      Visible         =   0   'False
      Width           =   750
   End
   Begin VB.Image imgMask 
      Height          =   750
      Index           =   2
      Left            =   1740
      Picture         =   "Main.frx":4340
      Top             =   840
      Visible         =   0   'False
      Width           =   750
   End
   Begin VB.Image imgMask 
      Height          =   750
      Index           =   1
      Left            =   900
      Picture         =   "Main.frx":451A
      Top             =   840
      Visible         =   0   'False
      Width           =   750
   End
   Begin VB.Image imgMask 
      Height          =   750
      Index           =   0
      Left            =   60
      Picture         =   "Main.frx":46F4
      Top             =   840
      Visible         =   0   'False
      Width           =   750
   End
   Begin VB.Image imgSprite 
      Height          =   750
      Index           =   3
      Left            =   2580
      Picture         =   "Main.frx":48CE
      Top             =   60
      Visible         =   0   'False
      Width           =   750
   End
   Begin VB.Image imgSprite 
      Height          =   750
      Index           =   2
      Left            =   1740
      Picture         =   "Main.frx":4EC8
      Top             =   60
      Visible         =   0   'False
      Width           =   750
   End
   Begin VB.Image imgSprite 
      Height          =   750
      Index           =   1
      Left            =   900
      Picture         =   "Main.frx":54C2
      Top             =   60
      Visible         =   0   'False
      Width           =   750
   End
   Begin VB.Image imgSprite 
      Height          =   750
      Index           =   0
      Left            =   60
      Picture         =   "Main.frx":5ABC
      Top             =   60
      Visible         =   0   'False
      Width           =   750
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdPlay_Click()
    Dim lResult As Long
    Dim picOldBack As StdPicture
    Dim StartTimer As Single
    Dim sngInterval As Single
    Dim iCounter As Integer
    Dim iNumFrames As Integer
    
    'We'll first make a copy of the background where the animation
    'will play. This is so we can restore it after the animation
    'does play
    lResult = BitBlt(picCurFrame.hDC, 0, 0, imgSprite(1).Width, imgSprite(1).Height, Me.hDC, 0, 0, SRCCOPY)
    Set picOldBack = picCurFrame.Image
    
    'Lets set our delay interval and number of frames
    sngInterval = 0.1
    StartTimer = Timer
    iNumFrames = 4
    
    'No we will loop through the Frames.
    For iCounter = 0 To iNumFrames - 1
        
        'Now we will cut out the area of the background to make room
        'for the sprite. We do this by using BitBlt to paint the Mask
        'Using the SRCAND. This will cut out only the black areas
        'of the mask
        Set picCurFrame.Picture = imgMask(iCounter).Picture
        lResult = BitBlt(Me.hDC, 0, 0, imgSprite(iCounter).Width, imgSprite(iCounter).Height, picCurFrame.hDC, 0, 0, SRCAND)
        
        'Now we will paint the sprite in the hole we cut out of the
        'background with the mask using SRCPAINT
        Set picCurFrame.Picture = imgSprite(iCounter).Picture
        lResult = BitBlt(Me.hDC, 0, 0, imgSprite(iCounter).Width, imgSprite(iCounter).Height, picCurFrame.hDC, 0, 0, SRCPAINT)
        Me.Refresh
        
        StartTimer = Timer
        Do While Timer < StartTimer + sngInterval
            DoEvents
        Loop
        
        'Refresh the background
        Set picCurFrame.Picture = picOldBack
        lResult = BitBlt(Me.hDC, 0, 0, imgSprite(iCounter).Width, imgSprite(iCounter).Height, picCurFrame.hDC, 0, 0, SRCCOPY)
        
    Next
    
    'Now lets loop it backwards
    For iCounter = iNumFrames - 1 To 0 Step -1
        
        'Cut out the mask
        Set picCurFrame.Picture = imgMask(iCounter).Picture
        lResult = BitBlt(Me.hDC, 0, 0, imgSprite(iCounter).Width, imgSprite(iCounter).Height, picCurFrame.hDC, 0, 0, SRCAND)
        
        'SRCPAINT the Sprite
        Set picCurFrame.Picture = imgSprite(iCounter).Picture
        lResult = BitBlt(Me.hDC, 0, 0, imgSprite(iCounter).Width, imgSprite(iCounter).Height, picCurFrame.hDC, 0, 0, SRCPAINT)
        Me.Refresh
        
        StartTimer = Timer
        Do While Timer < StartTimer + sngInterval
            DoEvents
        Loop
        
        'Refresh the background
        Set picCurFrame.Picture = picOldBack
        lResult = BitBlt(Me.hDC, 0, 0, imgSprite(iCounter).Width, imgSprite(iCounter).Height, picCurFrame.hDC, 0, 0, SRCCOPY)
        
    Next
    
    Me.Refresh
    
End Sub
